import questionsTemplate from './questions.template.html'

/* @ngInject */
let questionsComponent = {
  template: questionsTemplate,
  bindings: {
    questionsId: '='
  },
  transclude: true,
  controller: function ($scope, $http, $state,$log, $stateParams, $timeout, $cookies, appConstants, $localStorage, $location) {

    function setupExercise(exerciseData) {
      $scope.exercise = exerciseData
    }
    $scope.loc = $location.path().split('/').slice(-1).pop()

    $scope.token = 'Bearer ' + $cookies.get('API_TOKEN')
    $scope.questionCurrentId = $cookies.getObject('questionCurrentId')
    $scope.locId = $location.path().split('/').slice(-1).pop()
    if (angular.isDefined($scope.questionsCurrentId)) {
      $cookies.remove('questionCurrentId')
    }
    else {
      $cookies.putObject('questionCurrentId', $scope.locId)
      $scope.questionCurrentId = $scope.locId
    }
    // Get exercise data and setup
    $scope.$watch('[$ctrl.questionsId]', (n, o) => {
      if ($scope.$ctrl.questionsId) {
        $http.get(appConstants.api + '/exercise/' + $scope.$ctrl.questionsId, { headers: { 'Authorization': $scope.token } })
          .then((response) => {
            $scope.exercise = response.data
            $scope.qid =  $scope.$ctrl.questionsId
            $localStorage.$reset()
            $localStorage.exercises = []
            $localStorage.questionCount = $scope.exercise.interaction.questions.length
            $localStorage.questions = $scope.exercise.interaction.questions
            $localStorage.currentActiveExercise = 1
            $localStorage.currentActiveQuestion = $scope.step + 1
            // Assign new data
            $localStorage.playlist = [response.data]
            $localStorage.exerciseCount = $localStorage.playlist.length
            $localStorage.currentExercise = response.data.exercise_id
            $localStorage.currentActiveExercise = 1
          })
      } else if ($scope.loc !== 'questions' && $scope.loc !== 'practice') {
        $http.get(appConstants.api + '/exercise/' + $scope.questionCurrentId, { headers: { 'Authorization': $scope.token } })
          .then((response) => {
            $scope.exercise = response.data
            $scope.qid = $scope.questionCurrentId
            $localStorage.$reset()
            $localStorage.exercises = []
            $localStorage.questionCount = $scope.exercise.interaction.questions.length
            $localStorage.questions = $scope.exercise.interaction.questions
            $localStorage.currentActiveExercise = 1
            $localStorage.currentActiveQuestion = $scope.step + 1
            // Assign new data
            $localStorage.playlist = [response.data]
            $localStorage.exerciseCount = $localStorage.playlist.length
            $localStorage.currentExercise = response.data.exercise_id
            $localStorage.currentActiveExercise = 1
            $timeout(() => { $state.go('exercise') })
          })
      }
      else { // If we have loaded playlist then load the exercise from playlist
        setupExercise($localStorage.playlist.find((item) => item.exercise_id === $localStorage.currentExercise))
      }
    })
  }

}
export default questionsComponent
