/* eslint-disable */
describe('Mix exercise', function () {
    beforeEach(function () {
        var exercises = [2515, 2701, 2447, 2866];
        browser.get('/#!/questions/mix/' + exercises[Math.floor(Math.random() * (exercises.length - 1))]);
    });
    it('Should test drag and drop functionality', function () {
        var tilesContainer = element(by.id('tiles'));
        var extraTilesContainer = element(by.id('extra-tiles'));
        var tiles = element.all(by.repeater('tile in current.question.tiles'));

        element(by.css('[ng-show*="current.question.has_extra_tiles"]')).isDisplayed().then(function (displayed) {
            if (displayed) {
                tiles.count().then(function (tilesCountBefore) {
                    browser.actions().mouseMove(tiles.get(0)).mouseDown().mouseMove(extraTilesContainer, { x: 10, y: 10 }).mouseUp(extraTilesContainer).perform();
                    browser.sleep(500);
                    tiles.count().then(function (tilesCountAfter) {
                        expect(tilesCountBefore).not.toBe(tilesCountAfter);
                    });
                });
            } else {
                tiles.get(0).getText().then(function (textBefore) {
                    tiles.count().then(function (count) {
                        browser.actions().mouseMove(tiles.get(0)).mouseDown().mouseMove(tiles.get(count - 1), { x: 10, y: 10 }).mouseUp(tilesContainer).perform();
                        browser.sleep(500);
                        tiles.get(0).getText().then(function (textAfter) {
                            expect(textBefore).not.toBe(textAfter);
                        });
                    });

                });
            }
        });
    });

    it('Should test if the popup is shown', function () {
        element(by.id('actionButton')).click();
        expect((element(by.id('popupMessage'))).isDisplayed()).toBeTruthy();
    });

    it('Should test if the action button is going to next question after correct or incorrect answer', function () {
        element(by.id('actionButton')).click();
        browser.sleep(500);
        element(by.id('actionButton')).click();
        browser.sleep(500);
        element(by.id('actionButton')).click();
        browser.sleep(500);
        element(by.id('actionButton')).click();
        browser.sleep(500);

        var questionIndicator = element.all(by.repeater('page in pages track by page.number')).get(0);

        expect(questionIndicator.getAttribute('class')).not.toContain("active");
    });
});